<?php // $Id$

/* Define Flipping Rules *******************************
*******************************************************/

define('FLIP_PROPERTY', 'flip_property');
define('FLIP_DIRECTION', 'flip_direction');
define('FLIP_VALUE', 'flip_value');
define('FLIP_VALUE_POSITION', 'flip_value_position');
define('FLIP_BACKGROUND_POSITION', 'flip_background_position');

class cssflip {

  var $css;
  var $flipped_css;
  var $suppress;
  var $override;
  var $html;

  var $properties = array(
    'direction'       => FLIP_DIRECTION,
    'float'           => FLIP_VALUE,
    'text-align'      => FLIP_VALUE,     
    'margin'          => FLIP_VALUE_POSITION, 
    'padding'         => FLIP_VALUE_POSITION, 
    'left'            => FLIP_PROPERTY,
    'right'           => FLIP_PROPERTY,
    'margin-left'     => FLIP_PROPERTY,
    'margin-right'    => FLIP_PROPERTY,
    'padding-left'    => FLIP_PROPERTY,
    'padding-right'   => FLIP_PROPERTY, 
    'border-left'     => FLIP_PROPERTY, 
    'border-right'    => FLIP_PROPERTY,
    'background'      => FLIP_BACKGROUND_POSITION, 
    'background-position' => FLIP_BACKGROUND_POSITION,
  );

  function cssflip($html = true) {
    // Register "destructor"
    register_shutdown_function(array(&$this, "finalize"));
    $this->html = ($html != false);
    $this->clear();
  }

  function finalize() {
    unset($this->css);
  }
  
  function clear() {
    unset($this->css);
    $this->css = array();
    if($this->html) {
      $this->add("ADDRESS", "");
      $this->add("APPLET", "");
      $this->add("AREA", "");
      $this->add("A", "");
      $this->add("A:visited", "");
      $this->add("BASE", "");
      $this->add("BASEFONT", "");
      $this->add("BIG", "");
      $this->add("BLOCKQUOTE", "");
      $this->add("BODY", "");
      $this->add("BR", "");
      $this->add("B", "");
      $this->add("CAPTION", "");
      $this->add("CENTER", "");
      $this->add("CITE", "");
      $this->add("CODE", "");
      $this->add("DD", "");
      $this->add("DFN", "");
      $this->add("DIR", "");
      $this->add("DIV", "");
      $this->add("DL", "");
      $this->add("DT", "");
      $this->add("EM", "");
      $this->add("FONT", "");
      $this->add("FORM", "");
      $this->add("H1", "");
      $this->add("H2", "");
      $this->add("H3", "");
      $this->add("H4", "");
      $this->add("H5", "");
      $this->add("H6", "");
      $this->add("HEAD", "");
      $this->add("HR", "");
      $this->add("HTML", "");
      $this->add("IMG", "");
      $this->add("INPUT", "");
      $this->add("ISINDEX", "");
      $this->add("I", "");
      $this->add("KBD", "");
      $this->add("LINK", "");
      $this->add("LI", "");
      $this->add("MAP", "");
      $this->add("MENU", "");
      $this->add("META", "");
      $this->add("OL", "");
      $this->add("OPTION", "");
      $this->add("PARAM", "");
      $this->add("PRE", "");
      $this->add("P", "");
      $this->add("SAMP", "");
      $this->add("SCRIPT", "");
      $this->add("SELECT", "");
      $this->add("SMALL", "");
      $this->add("STRIKE", "");
      $this->add("STRONG", "");
      $this->add("STYLE", "");
      $this->add("SUB", "");
      $this->add("SUP", "");
      $this->add("TABLE", "");
      $this->add("TD", "");
      $this->add("TEXTAREA", "");
      $this->add("TH", "");
      $this->add("TITLE", "");
      $this->add("TR", "");
      $this->add("TT", "");
      $this->add("UL", "");
      $this->add("U", "");
      $this->add("VAR", "");
    }
  }

  function set_html($html) {
    $this->html = ($html != false);
  }

  function add($key, $codestr) {
    $key = strtolower($key);
    $codestr = strtolower($codestr);
    if(!isset($this->css[$key])) {
      $this->css[$key] = array();
    }
    $codes = explode(";",$codestr);
    if(count($codes) > 0) {
      foreach($codes as $code) {
        $code = trim($code);
        list($codekey, $codevalue) = explode(":",$code);
        if(strlen($codekey) > 0) {
          $this->css[$key][trim($codekey)] = trim($codevalue);
        }
      }
    }
  }

  function get($key, $property) {
    $key = strtolower($key);
    $property = strtolower($property);
    
    list($tag, $subtag) = explode(":",$key);
    list($tag, $class) = explode(".",$tag);
    list($tag, $id) = explode("#",$tag);
    $result = "";
    foreach($this->css as $_tag => $value) {
      list($_tag, $_subtag) = explode(":",$_tag);
      list($_tag, $_class) = explode(".",$_tag);
      list($_tag, $_id) = explode("#",$_tag);
      
      $tagmatch = (strcmp($tag, $_tag) == 0) | (strlen($_tag) == 0);
      $subtagmatch = (strcmp($subtag, $_subtag) == 0) | (strlen($_subtag) == 0);
      $classmatch = (strcmp($class, $_class) == 0) | (strlen($_class) == 0);
      $idmatch = (strcmp($id, $_id) == 0);
      
      if($tagmatch & $subtagmatch & $classmatch & $idmatch) {
        $temp = $_tag;
        if((strlen($temp) > 0) & (strlen($_class) > 0)) {
          $temp .= ".".$_class;
        } elseif(strlen($temp) == 0) {
          $temp = ".".$_class;
        }
        if((strlen($temp) > 0) & (strlen($_subtag) > 0)) {
          $temp .= ":".$_subtag;
        } elseif(strlen($temp) == 0) {
          $temp = ":".$_subtag;
        }
        if(isset($this->css[$temp][$property])) {
          $result = $this->css[$temp][$property];
        }
      }
    }
    return $result;
  }

  function get_section($key) {
    $key = strtolower($key);
    
    list($tag, $subtag) = explode(":",$key);
    list($tag, $class) = explode(".",$tag);
    list($tag, $id) = explode("#",$tag);
    $result = array();
    foreach($this->css as $_tag => $value) {
      list($_tag, $_subtag) = explode(":",$_tag);
      list($_tag, $_class) = explode(".",$_tag);
      list($_tag, $_id) = explode("#",$_tag);
      
      $tagmatch = (strcmp($tag, $_tag) == 0) | (strlen($_tag) == 0);
      $subtagmatch = (strcmp($subtag, $_subtag) == 0) | (strlen($_subtag) == 0);
      $classmatch = (strcmp($class, $_class) == 0) | (strlen($_class) == 0);
      $idmatch = (strcmp($id, $_id) == 0);
      
      if($tagmatch & $subtagmatch & $classmatch & $idmatch) {
        $temp = $_tag;
        if((strlen($temp) > 0) & (strlen($_class) > 0)) {
          $temp .= ".".$_class;
        } elseif(strlen($temp) == 0) {
          $temp = ".".$_class;
        }
        if((strlen($temp) > 0) & (strlen($_subtag) > 0)) {
          $temp .= ":".$_subtag;
        } elseif(strlen($temp) == 0) {
          $temp = ":".$_subtag;
        }
        foreach($this->css[$temp] as $property => $value) {
          $result[$property] = $value;
        }
      }
    }
    return $result;
  }

  function parse($str) {
    $this->clear();
    // Remove comments
    $str = preg_replace("/\/\*(.*)?\*\//Usi", "", $str);
    // parse_file this damn csscode
    $parts = explode("}",$str);
    if(count($parts) > 0) {
      foreach($parts as $part) {
        list($keystr,$codestr) = explode("{",$part);
        $keys = explode(",",trim($keystr));
        if(count($keys) > 0) {
          foreach($keys as $key) {
            if(strlen($key) > 0) {
              $key = str_replace("\n", "", $key);
              $key = str_replace("\\", "", $key);
              $this->add($key, trim($codestr));
            }
          }
        }
      }
    }
    //
    return (count($this->css) > 0);
  }

  function parse_file($filename) {
    $this->clear();
    if(file_exists($filename)) {
      return $this->parse(file_get_contents($filename));
    } else {
      return false;
    }
  }   
  
  function get_css() {
    $result = "";
    foreach($this->css as $key => $values) {
      $result .= $key." {\n";
      foreach($values as $key => $value) {
        $result .= "  $key: $value;\n";
      }
      $result .= "}\n\n";
    }
    return $result;
  }

  function format_css($css_array = array()) {
    $result = "";
    foreach($css_array as $key => $values) {
      $result .= $key." {\n";
      foreach($values as $key => $value) {
        $result .= "  $key: $value;\n";
      }
      $result .= "}\n\n";
    }
    return $result;
  }  
  
  function flip() {
    $css = $this->css;
    $properties = $this->properties;
    $flipped_css = array();

    foreach ($css as $selector => $attrs) {
  		if($attrs) {
  			foreach ($attrs as $property => $value) { 
            if (isset($properties[$property])) {
             	$function = $properties[$property];
             	
             	if(!is_array($flipped_css[$selector]))
             	   $flipped_css[$selector] = array();
             	   
             	$flipped_css[$selector] += $this->$function($property, $value);
            } else if(!$this->suppress) {
              $flipped_css[$selector][$property] = $css[$selector][$property];
            }  			   
  			}
  		}     
    }
    
    $this->flipped_css = $flipped_css;
    return $this->format_css($flipped_css);
  }

  /**** Flipping fucntions ****/
  
  function flip_property($property, $value) {
    $output = array();
    
    if($this->override) {
      // Reset and override the original value
      $output[$property] = 'auto !important';      
    }
    
    if(preg_match('/left/', $property)) {
      $property = str_replace('left', 'right', $property);  
    } else if(preg_match('/right/', $property)) {
      $property = str_replace('right', 'left', $property);  
    }
    
    $output[$property] = $value;
    return $output;
  }
  
  function flip_direction($property, $value) {
      return array($property => ($value == 'ltr' ? 'rtl' : 'ltr'));  
  }
  
  function flip_value($property, $value) {
      return array($property => ($value == 'left' ? 'right' : 'left'));
  }
  
  function flip_value_position($property, $value) {
      $pos = explode(' ', $value);
      
      if(sizeof($pos) >= 3) {
        $temp = $pos[1];
        $pos[3] = ($pos[3] ? $pos[3] : 0);
        $pos[1] = $pos [3];
        $pos[3] = $temp;
        unset($temp);
      }
      
      return array($property => implode(' ', $pos)); 
  }

  function flip_background_position($property, $value) {
    if(preg_match('/ left /', $value)) {
      $value = str_replace(' left ', ' right ', $value);  
    } else if(preg_match('/ right /', $value)) {
      $value = str_replace(' right ', ' left ', $value);  
    }
    
    if(preg_match('/[0-9]*\%/', $value, $matches)) {
      $pos = 100 - (int)(str_replace('%', '', $matches[0]));
      $value = str_replace($matches[0], "{$pos}%", $value);
    }
    
    return array($property => $value);    
  }   
}